var list = {

	"Manual": {
		"Introduction": [
			[ "Creating a scene", "manual/introduction/Creating-a-scene" ]
		]
	},

	"Reference": {
    "Constants": [
      [ "CustomBlendingEquation", "api/constants/CustomBlendingEquations"],
      [ "GLState", "api/constants/GLState"],
      [ "Materials", "api/constants/Materials"],
      [ "ShadowingTypes", "api/constants/ShadowingTypes"],
      [ "Textures", "api/constants/Textures"]
    ],

		"Cameras": [
			[ "Camera", "api/cameras/Camera" ],
			[ "OrthographicCamera", "api/cameras/OrthographicCamera" ],
			[ "PerspectiveCamera", "api/cameras/PerspectiveCamera" ]
		],

		"Core": [
			[ "BufferGeometry", "api/core/BufferGeometry" ],
			[ "Clock", "api/core/Clock" ],
			[ "EventDispatcher", "api/core/EventDispatcher" ],
			[ "Face3", "api/core/Face3" ],
			[ "Geometry", "api/core/Geometry" ],
			[ "Object3D", "api/core/Object3D" ],
			[ "Projector", "api/core/Projector" ],
			[ "Raycaster", "api/core/Raycaster" ],
		],

		"Lights": [
			[ "Light", "api/lights/Light" ],
			[ "AmbientLight", "api/lights/AmbientLight" ],
			[ "AreaLight", "api/lights/AreaLight" ],
			[ "DirectionalLight", "api/lights/DirectionalLight" ],
			[ "HemisphereLight", "api/lights/HemisphereLight" ],
			[ "PointLight", "api/lights/PointLight" ],
			[ "SpotLight", "api/lights/SpotLight" ]
		],


		"Loaders": [
			[ "Loader", "api/loaders/Loader" ],
			[ "GeometryLoader", "api/loaders/GeometryLoader" ],
			[ "ImageLoader", "api/loaders/ImageLoader" ],
			[ "JSONLoader", "api/loaders/JSONLoader" ],
			[ "LoadingManager", "api/loaders/LoadingManager" ],
			[ "SceneLoader", "api/loaders/SceneLoader" ],
			[ "TextureLoader", "api/loaders/TextureLoader" ],
		],

		"Materials": [
			[ "Material", "api/materials/Material" ],
			[ "LineBasicMaterial", "api/materials/LineBasicMaterial" ],
			[ "LineDashedMaterial", "api/materials/LineDashedMaterial" ],
			[ "MeshBasicMaterial", "api/materials/MeshBasicMaterial" ],
			[ "MeshDepthMaterial", "api/materials/MeshDepthMaterial" ],
			[ "MeshFaceMaterial", "api/materials/MeshFaceMaterial" ],
			[ "MeshLambertMaterial", "api/materials/MeshLambertMaterial" ],
			[ "MeshNormalMaterial", "api/materials/MeshNormalMaterial" ],
			[ "MeshPhongMaterial", "api/materials/MeshPhongMaterial" ],
			[ "ParticleSystemMaterial", "api/materials/ParticleSystemMaterial" ],
			[ "ShaderMaterial", "api/materials/ShaderMaterial" ],
			[ "SpriteMaterial", "api/materials/SpriteMaterial" ],
			[ "SpriteCanvasMaterial", "api/materials/SpriteCanvasMaterial" ]
		],

		"Math": [
			[ "Box2", "api/math/Box2" ],
			[ "Box3", "api/math/Box3" ],
			[ "Color", "api/math/Color" ],
			[ "Euler", "api/math/Euler" ],
			[ "Frustum", "api/math/Frustum" ],
			[ "Line3", "api/math/Line3" ],
			[ "Math", "api/math/Math" ],
			[ "Matrix3", "api/math/Matrix3" ],
			[ "Matrix4", "api/math/Matrix4" ],
			[ "Plane", "api/math/Plane" ],
			[ "Quaternion", "api/math/Quaternion" ],
			[ "Ray", "api/math/Ray" ],
			[ "Sphere", "api/math/Sphere" ],
			[ "Spline", "api/math/Spline" ],
			[ "Triangle", "api/math/Triangle" ],
			[ "Vector2", "api/math/Vector2" ],
			[ "Vector3", "api/math/Vector3" ],
			[ "Vector4", "api/math/Vector4" ]
		],

		"Objects": [
			[ "Bone", "api/objects/Bone" ],
			[ "Line", "api/objects/Line" ],
			[ "LOD", "api/objects/LOD" ],
			[ "Mesh", "api/objects/Mesh" ],
			[ "MorphAnimMesh", "api/objects/MorphAnimMesh" ],
			[ "ParticleSystem", "api/objects/ParticleSystem" ],
			[ "SkinnedMesh", "api/objects/SkinnedMesh" ],
			[ "Sprite", "api/objects/Sprite" ]

		],

		"Renderers": [
			[ "CanvasRenderer", "api/renderers/CanvasRenderer" ],
			[ "WebGLRenderer", "api/renderers/WebGLRenderer" ],
			[ "WebGLRenderTarget", "api/renderers/WebGLRenderTarget" ],
			[ "WebGLRenderTargetCube", "api/renderers/WebGLRenderTargetCube" ]
		],

		"Renderers / Renderables": [
			[ "RenderableFace3", "api/renderers/renderables/RenderableFace3" ],
			[ "RenderableLine", "api/renderers/renderables/RenderableLine" ],
			[ "RenderableObject", "api/renderers/renderables/RenderableObject" ],
			[ "RenderableParticle", "api/renderers/renderables/RenderableParticle" ],
			[ "RenderableVertex", "api/renderers/renderables/RenderableVertex" ]
		],

		"Renderers / Shaders": [
			[ "ShaderChunk", "api/renderers/shaders/ShaderChunk" ],
			[ "UniformsUtils", "api/renderers/shaders/UniformsUtils" ],
			[ "UniformsLib", "api/renderers/shaders/UniformsLib" ],
			[ "ShaderLib", "api/renderers/shaders/ShaderLib" ]
		],

		"Scenes": [
			[ "Fog", "api/scenes/Fog" ],
			[ "FogExp2", "api/scenes/FogExp2" ],
			[ "Scene", "api/scenes/Scene" ]
		],

		"Textures": [
			[ "CompressedTexture", "api/textures/CompressedTexture" ],
			[ "DataTexture", "api/textures/DataTexture" ],
			[ "Texture", "api/textures/Texture" ]
		],

		"Extras": [
			[ "FontUtils", "api/extras/FontUtils" ],
			[ "GeometryUtils", "api/extras/GeometryUtils" ],
			[ "ImageUtils", "api/extras/ImageUtils" ],
			[ "SceneUtils", "api/extras/SceneUtils" ]
		],

		"Extras / Animation": [
			[ "Animation", "api/extras/animation/Animation" ],
			[ "AnimationHandler", "api/extras/animation/AnimationHandler" ],
			[ "AnimationMorphTarget", "api/extras/animation/AnimationMorphTarget" ],
			[ "KeyFrameAnimation", "api/extras/animation/KeyFrameAnimation" ]
		],

		"Extras / Cameras": [
			[ "CombinedCamera", "api/extras/cameras/CombinedCamera" ],
			[ "CubeCamera", "api/extras/cameras/CubeCamera" ]
		],

		"Extras / Core": [
			[ "Curve", "api/extras/core/Curve" ],
			[ "CurvePath", "api/extras/core/CurvePath" ],
			[ "Gyroscope", "api/extras/core/Gyroscope" ],
			[ "Path", "api/extras/core/Path" ],
			[ "Shape", "api/extras/core/Shape" ]
		],

		"Extras / Geometries": [
			[ "CircleGeometry", "api/extras/geometries/CircleGeometry" ],
			[ "ConvexGeometry", "api/extras/geometries/ConvexGeometry" ],
			[ "CubeGeometry", "api/extras/geometries/CubeGeometry" ],
			[ "CylinderGeometry", "api/extras/geometries/CylinderGeometry" ],
			[ "ExtrudeGeometry", "api/extras/geometries/ExtrudeGeometry" ],
			[ "IcosahedronGeometry", "api/extras/geometries/IcosahedronGeometry" ],
			[ "LatheGeometry", "api/extras/geometries/LatheGeometry" ],
			[ "OctahedronGeometry", "api/extras/geometries/OctahedronGeometry" ],
			[ "ParametricGeometry", "api/extras/geometries/ParametricGeometry" ],
			[ "PlaneGeometry", "api/extras/geometries/PlaneGeometry" ],
			[ "PolyhedronGeometry", "api/extras/geometries/PolyhedronGeometry" ],
			[ "ShapeGeometry", "api/extras/geometries/ShapeGeometry" ],
			[ "SphereGeometry", "api/extras/geometries/SphereGeometry" ],
			[ "TetrahedronGeometry", "api/extras/geometries/TetrahedronGeometry" ],
			[ "TextGeometry", "api/extras/geometries/TextGeometry" ],
			[ "TorusGeometry", "api/extras/geometries/TorusGeometry" ],
			[ "TorusKnotGeometry", "api/extras/geometries/TorusKnotGeometry" ],
			[ "TubeGeometry", "api/extras/geometries/TubeGeometry" ]
		],

		"Extras / Helpers": [
			[ "ArrowHelper", "api/extras/helpers/ArrowHelper" ],
			[ "AxisHelper", "api/extras/helpers/AxisHelper" ],
			[ "CameraHelper", "api/extras/helpers/CameraHelper" ],
			[ "DirectionalLightHelper", "api/extras/helpers/DirectionalLightHelper" ],
			[ "GridHelper", "api/extras/helpers/GridHelper" ],
			[ "HemisphereLightHelper", "api/extras/helpers/HemisphereLightHelper" ],
			[ "PointLightHelper", "api/extras/helpers/PointLightHelper" ],
			[ "SpotLightHelper", "api/extras/helpers/SpotLightHelper" ]
		],

		"Extras / Objects": [
			[ "ImmediateRenderObject", "api/extras/objects/ImmediateRenderObject" ],
			[ "LensFlare", "api/extras/objects/LensFlare" ],
			[ "MorphBlendMesh", "api/extras/objects/MorphBlendMesh" ]
		],

		"Extras / Renderers / Plugins": [
			[ "DepthPassPlugin", "api/extras/renderers/plugins/DepthPassPlugin" ],
			[ "LensFlarePlugin", "api/extras/renderers/plugins/LensFlarePlugin" ],
			[ "ShadowMapPlugin", "api/extras/renderers/plugins/ShadowMapPlugin" ],
			[ "SpritePlugin", "api/extras/renderers/plugins/SpritePlugin" ]
		],

		"Extras / Shaders": [
			[ "ShaderFlares", "api/extras/shaders/ShaderFlares" ],
			[ "ShaderSprite", "api/extras/shaders/ShaderSprite" ]
		]
	}

};

var pages = {};

for ( var section in list ) {

	pages[ section ] = {};

	for ( var category in list[ section ] ) {

		pages[ section ][ category ] = {};

		for ( var i = 0; i < list[ section ][ category ].length; i ++ ) {

			var page = list[ section ][ category ][ i ];
			pages[ section ][ category ][ page[ 0 ] ] = page[ 1 ];

		}

	}

}
